<script lang="ts">
    import { onMount } from "svelte";
    import "pickerjs/dist/picker.css";
    import Picker from "pickerjs";
    import { createEventDispatcher } from "svelte";
    const dispatch = createEventDispatcher();

    export let header = "ระบุวันเกิดของคุณ";
    export let value = "";
    export let placeholder = "ระบุวันเกิด";
    export let inputCss = "w-full text-right border border-transparent ";

    let inputDate: any;
    let _birth: string;
    let timeOut;

    const months = [
        "มกราคม",
        "กุมภาพันธ์",
        "มีนาคม",
        "เมษายน",
        "พฤษภาคม",
        "มิถุนายน",
        "กรกฏาคม",
        "สิงหาคม",
        "กันยายน",
        "ตุลาคม",
        "พฤศจิกายน",
        "ธันวาคม",
    ];
    const monthsShort = [
        "ม.ค",
        "ก.พ",
        "ม.ค",
        "เม.ย",
        "พ.ค",
        "มิ.ย",
        "ก.ค",
        "ส.ค",
        "ก.ย",
        "ต.ค",
        "พ.ย",
        "ธ.ค",
    ];

    onMount(() => {
        let converFomatDate = "";
        if (value) {
            const dateVal = value;
            let date = dateVal.split("/")[0];
            let month = months[+dateVal.split("/")[1]-1]
            const year = dateVal.split("/")[2];
            converFomatDate = `${month}/${date}/${year}`;
        }

        new Picker(inputDate, {
            months: months,
            monthsShort: monthsShort,
            headers: false,
            controls: true,
            format: "MMMM/D/YYYY",
            date: converFomatDate ? converFomatDate : "มิถุนายน/10/1999",
            // rows: 4,
            text: {
                title: header,
                cancel: "ยกเลิก",
                confirm: "ยืนยัน",
                month: "เดือน",
                year: "ปี",
                day: "วัน",
            },
        });

        if (value) {
            _birth = value;
        }
    });

    function onInputDateChanged(event: any) {
        timeOut = setTimeout(() => {
            const dateVal = event.target.value;
            let date = dateVal.split("/")[1];
            let month: any = paseMonth(dateVal.split("/")[0]) + 1;
            const year = dateVal.split("/")[2];
            if (month < 10) {
                month = "0" + month;
            }
            if (date < 10) {
                date = "0" + date;
            }
            _birth = `${date}/${month}/${year}`;
            value = _birth;

            dispatch("inputDateChange", {
                date: date,
                month: month,
                year: year,
            });
        }, 500);
    }

    function paseMonth(month: string) {
        return months.findIndex((dt) => dt === month) !== -1
            ? months.findIndex((dt) => dt === month)
            : monthsShort.findIndex((dt) => dt === month);
    }
</script>

<div class="w-full flex justify-center">
    <div class="w-full border border-gray-400">
        <input
            id="i_birthday"
            on:change={(event) => console.log(event)}
            on:change={onInputDateChanged}
            bind:value={_birth}
            bind:this={inputDate}
            name="birth"
            type="text"
            class={inputCss}
            {placeholder}
        />
    </div>
</div>
